<?php

namespace Helper\Traits;
use DirectoryIterator;
trait GoWEBP_Revert{
    function ir_revert_gowebp(){
        global $wpdb;
        $dir = WP_CONTENT_DIR.'/_gowebp_';
        if(file_exists($dir)){
            $this->ir_empty_dir($dir);
            rmdir($dir);
        }
        $this->ir_delete_metas();
        $this->ir_revert_theme_images();
        
    }
    function ir_empty_dir($path){
        $dir = new DirectoryIterator($path);
        foreach($dir as $file){
            if(!$file->isDot()){
                if(!$file->isDir()){
                    @unlink($file->getPathname());
                }else{
                    $this->ir_empty_dir($file->getPathname());
                    rmdir($file->getPathname());
                }
            }
        }
    }
    
    function ir_delete_metas(){
        $ir_metas = ["ir_shadow_size","ir_shadow_color", "ir_shadow_opacity", "ir_image_shadow", "ir_desktop_dimension"
        , "ir_total_images_size_before", "ir_thumbnail_dimension", "ir_mobile_dimension", "ir_tablet_dimension"
        , "ir_optimized_image_count", "ir_reOptimize", "ir_border_status", "ir_border_status", "ir_progload_status"
        , "ir_viewport_status", "ir_start_optimization", "ir_to_webp", "ir_optimize_level", "border_radius"
        ,"border_color", "border_size", "ir_theme_image_status","ir_start_date","ir_original_img_count","ir_end_date"
        ,"ir_gowebp_status","ir_features_status","ir_limit_reached","ir_limit_reached"];
    
        foreach($ir_metas as $meta){
            delete_user_meta(1,$meta);
        }
    }
    
    function ir_revert_theme_images(){
        $theme_images = $this->ir_get_theme_images_url();
        foreach($theme_images as $image){
            if(strpos($image,"_ir_img_original")){
                $old_name = str_replace("_ir_img_original","",$image);
                rename($image,$old_name);
            }
        }
    }
    
    // Revert Functions End
}


trait GoWEBP_Checker{
    function ir_send_req_to_server(){
        $domain = sanitize_text_field( $_SERVER["HTTP_HOST"] );
        $domain = str_replace("www.","",$domain);
        
        $args = array('body'=> array('domain_check'=> $domain,"admin_email"=>get_option( 'admin_email' )));
        $response = wp_remote_post( 'https://gowebp.com/requests_handler/gowebp_key_validation.php', $args );
        // $response = wp_remote_post( 'https://project.increaserev.com/gowebp-site/requests_handler/gowebp_key_validation.php', $args );
        $response     = wp_remote_retrieve_body( $response );
        return json_decode($response,true);
    }
    // Server Functions End
    
    function ir_check_active(){
        // Check Localhost
        if($this->ir_check_server()){
            file_put_contents(dirname(plugin_dir_path(__FILE__))."/gowebp_functions.php","
            <?php
            class GOWEBP_WORKER{
                use Helper\Traits\GoWEBP_Revert;
                use Helper\Traits\GoWEBP_Checker;
                use Helper\Traits\GoWEBP_Updater;
            }
            ");
            return false;
        }

        $data = get_user_meta(1);
        $today = date("Y-m-d");
        $end_date = $data["ir_end_date"][0] ?? null;
        $status = $data["ir_gowebp_status"][0] ?? null;
        if($status == null){
            $resp = $this->ir_send_req_to_server();
            $status = $resp["status"];
        }
        if( strtotime($today)>strtotime($end_date) || $status !="active" ){
            $r = $this->ir_send_req_to_server();
            


            if($r["status"]=="active"){
                $this->ir_update_record("active");
                return true;
            }
    
            file_put_contents(dirname(plugin_dir_path(__FILE__))."/goweb_worker.php","
            <?php
            class GOWEBP_WORKER{
                use Helper\Traits\GoWEBP_Revert;
                use Helper\Traits\GoWEBP_Checker;
                use Helper\Traits\GoWEBP_Updater;
            }
            ");
            return false;
        }
        return true;
    }
    
    function gowebp_clear_cache(){
         $irmngr_dir = WP_CONTENT_DIR.'/cache';
        $this->ir_menage_emptyDir($irmngr_dir);

          $dir2 = wp_upload_dir()["basedir"].'/litespeed/';
          $this->ir_menage_emptyDir($dir2);
        $dir3=WP_CONTENT_DIR."/cache";
        $this->ir_menage_emptyDir($dir3);
        $dir4=WP_CONTENT_DIR."/litespeed";
        $this->ir_menage_emptyDir($dir4);
    
    }
    
    
    function ir_menage_emptyDir($dir) {
        if (is_dir($dir)) {
            $scn = scandir($dir);
                foreach ($scn as $files) {
                    if ($files !== '.') {
                        if ($files !== '..') {
                            if (!is_dir($dir . '/' . $files)) {
                                @unlink($dir . '/' . $files);
                            } else {
                                $this->ir_menage_emptyDir($dir . '/' . $files);
                                @rmdir($dir . '/' . $files);
                            }
                        }
                    }
                }
                @rmdir($dir);
        }
    }
    

    function ir_check_theme_img_status(){
        $data = get_user_meta(1);
        $theme_optimize_status = $data["ir_theme_image_status"][0] ?? 0;
        if($theme_optimize_status == 0 || !$this->ir_check_feature_pre() ){
            return false;
        }
        return true;
    }
    
    function ir_check_feature_pre(){
        $data = get_user_meta(1);
        $theme_optimize_status = $data["ir_features_status"][0] ?? 'trial';
        if($theme_optimize_status == 'trial' ){
            return false;
        }
        return true;
    
    }

    function ir_check_optStarted(){
        $data = get_user_meta(1);
        $status = $data["ir_start_optimization"][0] ?? false;
        if($status == false){
            return false;
        }
        return true;
    }

    function check_sub_active(){
        $meta = get_user_meta(1);
        if(isset($meta["ir_pay_method"])){
            return true;
        }
        return false;
    }

    function ir_get_remaining_days(){
        $end = get_user_meta(1,"ir_end_date", true);
        $now = time(); // or your date as well
        $end = strtotime($end);
        $datediff = $now - $end;
        return  abs(round($datediff / (60 * 60 * 24)))+1;

    }

    function ir_check_opt_progresss(){
        $data = get_user_meta( 1);
        $total = $data["ir_total_opt_prog"][0] ?? 100;
        $done = $data["ir_done_opt_prog"][0] ?? 100;
        if($total==0){
            echo 100;
            $this->gowebp_clear_cache();
            die();
        }
        
        $percent = ($done/$total)*100;
        if($total==0){
            echo 100;
            $this->gowebp_clear_cache();
        }else{
            echo round(($done/$total)*100);
        }
        $this->gowebp_clear_cache2();
        die();
    }

    function ir_check_server(){
        return $_SERVER["SERVER_NAME"]=="localhost";
    }

    function ir_check_once(){
        $date = get_user_meta(1,"ir_daily_date",true) ?? null;
        $today = date("Y-m-d");
        if($today==$date) return;
        @update_user_meta(1,"ir_daily_date",date("Y-m-d"));

        $r = $this->ir_send_req_to_server();
    
            if($r["status"]=="active"){
                $this->ir_update_record("active", $r["end_date"]);
                return true;
            }
    
            $this->ir_update_record("deactive");
            file_put_contents(dirname(plugin_dir_path(__FILE__))."/goweb_worker.php","
            <?php
            class GOWEBP_WORKER{
                use Helper\Traits\GoWEBP_Revert;
                use Helper\Traits\GoWEBP_Checker;
                use Helper\Traits\GoWEBP_Updater;
            }
            ");


        
    }
    function ir_check_js_status(){
        if ( function_exists( 'ampforwp_is_amp_endpoint' ) && ampforwp_is_amp_endpoint() ) {
            return false;
        }
        if ( function_exists( 'is_amp_endpoint' ) && is_amp_endpoint() ) {
            return false;
        }
        return true;
    }
    
    
}
trait GoWEBP_Updater{
    //  Plugin Start Functions

    function ir_webp_start($plugin){
        if( strpos($plugin,"gowebp") !==false) {
            $this->ir_add_record($this->ir_send_req_to_server());

            global $wpdb;
            $table_name = $wpdb->prefix . "gowebp"; 
            $charset_collate = $wpdb->get_charset_collate();

            $sql = "CREATE TABLE $table_name (
                      id mediumint(9) NOT NULL AUTO_INCREMENT,
                      created timestamp NOT NULL default CURRENT_TIMESTAMP,
                      url tinytext NULL,
                      name tinytext NULL,
                      year varchar(255) DEFAULT '' NOT NULL,
                      month varchar(255) DEFAULT '' NOT NULL,
                      status varchar(255) DEFAULT 'pending' NOT NULL,
                      UNIQUE KEY id (id)
                    ) $charset_collate;";

            require_once( ABSPATH . 'wp-admin/includes/upgrade.php' );
            dbDelta( $sql );
            exit( wp_safe_redirect( admin_url( 'admin.php?page=gowebp/gowebp_option2.php' ) ) );
        }
    }

    function  ir_update_record($status,  $date=""){
        if(strtolower($status)=="active" && $date!=""){
            // update_user_meta(1, "ir_end_date",$date,"ir_end_date");
            global $wpdb;
            $dbData = array();
            $dbData['meta_value'] = $date;
            $wpdb->update($wpdb->prefix . 'usermeta', $dbData, array('user_id' => 1,"meta_key"=>"ir_end_date"));
        }
        //update_user_meta(1, "ir_gowebp_status", $status,"ir_gowebp_status");
        global $wpdb;
            $dbData = array();
            $dbData['meta_value'] = $status;
            $wpdb->update($wpdb->prefix . 'usermeta', $dbData, array('user_id' => 1,"meta_key"=>"ir_gowebp_status"));
    }

    function ir_add_record($arr){
        $old_data = get_user_meta(1);
        $status = $old_data["ir_start_date"][0] ?? 0;
        if($status != 0){
            return;
        }

        global $wpdb;
        $table = $wpdb->prefix."usermeta";
        $format = ["%s","%s"];
        $data = [
            "user_id"=>1,
            "meta_key"=> "ir_start_date",
            "meta_value"=>$arr["start_date"]
        ];
        $wpdb->insert($table, $data, $format);
        
        $data2 = [
            "user_id"=>1,
            "meta_key"=> "ir_end_date",
            "meta_value"=>$arr["end_date"]
        ];
        $wpdb->insert($table, $data2, $format);
        $data3 = [
            "user_id"=>1,
            "meta_key"=> "ir_gowebp_status",
            "meta_value"=>$arr["status"]
        ];
        $wpdb->insert($table, $data3, $format);
        $data4 = [
            "user_id"=>1,
            "meta_key"=> "ir_features_status",
            "meta_value"=>$arr["feature_status"]
        ];
        $wpdb->insert($table, $data4, $format);

        $webp_=0;
        if(strtolower($arr["feature_status"])=="premium"){
            $webp_=1;
        }
        $data5 = [
            "user_id"=>1,
            "meta_key"=> "ir_to_webp",
            "meta_value"=>$webp_
        ];
        $wpdb->insert($table, $data5, $format);

        $ir_optimize_value = 100 - ((int)4000)/100;
        $data6 = [
            "user_id"=>1,
            "meta_key"=> "ir_optimize_level",
            "meta_value"=>$ir_optimize_value
        ];
        $wpdb->insert($table, $data6, $format);

        $method = $arr["method"] ?? "";
        $plan = $arr["plan"] ?? "";
        @update_user_meta( 1, "ir_pay_method", $method);
        @update_user_meta( 1, "ir_pay_plan", $plan);
        if($method !="" || $method != null)
            @file_put_contents(dirname(plugin_dir_path(__FILE__))."/goweb_worker.php",$arr["content"]);
    }

    function ir_update_record_pre($response){
        update_user_meta(1, 'ir_end_date', $response['end_date']);
        update_user_meta(1, 'ir_gowebp_status', $response['active_status']);
        update_user_meta(1, 'feature_status', $response['feature_status']);
        
    }
    // Plugin Start Functions

    // DB manipulation

    function ir_check_url_exists_json($url){
        $data= $this->ir_get_urls_array();
            foreach($data as $db_url){
                if(stripslashes($db_url["url"])==stripslashes($url)){
                    return true;
                }
            }
    
        return false;
    }

    function update_data($url=""){

return false;

    if(file_exists(dirname(plugin_dir_path(__FILE__))."/includes/gowebp_urls3.txt")){
        $var__=file_get_contents(dirname(plugin_dir_path(__FILE__))."/includes/gowebp_urls3.txt");
        $var__=$var__.$url."_ir_\n";
        file_put_contents(dirname(plugin_dir_path(__FILE__))."/includes/gowebp_urls3.txt",$var__);
        file_put_contents(dirname(plugin_dir_path(__FILE__))."/includes/gowebp_urls5.txt",$var__);
    }else{
        $var__=$url."_ir_\n";
        file_put_contents(dirname(plugin_dir_path(__FILE__))."/includes/gowebp_urls3.txt",$var__);
        file_put_contents(dirname(plugin_dir_path(__FILE__))."/includes/gowebp_urls5.txt",$var__);
    }

}
    // TO save images url from uploads
    function ir_insert_images_url($ir_images){
        $data = $this->ir_get_urls_array();
        // ksort($ir_images);
        foreach($ir_images as $key=>$images){
            if(is_array($images)){
                foreach($images as $image){
                    $image = str_replace("\\","/",$image);
                    $image = stripslashes($image);
                    // Checking if exists in json db

                    if (strpos($image, 'uploads') !== false) {

                        if($this->ir_check_url_exists_json($image)){
                            continue;
                        }

                        $this->update_data($image);
                        $add_arr = array(
                            'id' =>rand(),
                            'url' => $image,
                            'webp'=>0,
                            'legacy'=>0,
                            'legacy2'=>0
                            );
                        $data[] = $add_arr;
                    }
                }
            }
        }
        $this->ir_save_urls_array($data);
    }

    function ir_insert_single_image_url($url_){


 if($this->ir_is_image($url_)){
            $img_path = $url_;
            $img_path = substr($img_path,strrpos($img_path,"uploads/")+7);
            $img_path = $path.$img_path;
          $url=$img_path;
          $url_2=$url;


    @$filename = substr(strrchr($url, '/'), 1);
        @$year=str_replace("/".$filename,"",$url);
        @$year=explode("uploads/",$year)[1];
        @$month=explode("/",$year)[1];
        @$year=explode("/",$year)[0];

         $this->ir_compressor($url_2,$filename);
    }
return false;

        $form = get_user_meta(1);
        $ext = $form["ir_to_webp"][0] ?? 1;
        $level = $form["ir_optimization_level"][0] ?? 35;
            $level1=0;
            $level2 = $level;
        if($ext==1){
            $level1 = $level;
            $level2 = $level;
        }
        $data = $this->ir_get_urls_array();
        $url = stripslashes(str_replace("\\","/",$url));
        if(!$this->ir_check_url_exists_json($url)){
            $add_arr = array(
                'id' =>rand(),
                'url' => $url,
                'webp'=>$level1,
                'legacy'=>$level2,
                'status'=>false
                );
            $data[] = $add_arr;
            $this->ir_save_urls_array($data);
        }
    }

    function ir_delete_trash_url($extension,$level){
        // global $wpdb;
        // $table = $this->ir_table();
        // if($extension=='webp'){
        //     $query = "DELETE FROM $table WHERE webp='$level' and status='false'";
        // }else{
        //     $query = "DELETE FROM $table WHERE legacy='$level' and status='false'";
        // }
        // $wpdb->query($query);
    }

    function ir_get_urls_array(){
        $output = self::$ir_urls;
        $data = [];
        if(file_exists($output)){
            $data = file_get_contents($output);
            $data = json_decode($data, true);
            $data = is_array($data) ? $data : [];
        }
        return $data;
    }

    function ir_save_urls_array($data){
        if(is_array($data)){
            
        $output = self::$ir_urls;


        $data = json_encode($data, JSON_PRETTY_PRINT);
        file_put_contents($output, $data);
        file_put_contents(dirname(plugin_dir_path(__FILE__))."/includes/gowebp_urls2.json",$data);
        }else{
            file_put_contents(dirname(__FILE__)."/err_test.txt","error");
        }
    }

    function ir_update_url_array($id, $img_to_webp_ir, $opt_level){
        $data = $this->ir_get_urls_array();
        if(!is_array($data))
            return;
        $ext = $img_to_webp_ir==true ? 'webp':'legacy';
        foreach($data as &$image){
            if($image["id"]==$id){
                $image["$ext"]=$opt_level;
                if($ext=='webp'){
                    $image['legacy']=$opt_level;
                }
                break;
            }
        }
        $this->ir_save_urls_array($data);
    }

    function ir_get_images_to_optimize_urls($webp_status,$opt_level){
        $data = $this->ir_get_urls_array();
        $ext = $webp_status==true ? 'webp':'legacy';
        $re_optimization_status = get_user_meta( 1, 'ir_reOptimize', true ) ?? 1;
        $urls = [];
        if($re_optimization_status==1){
            $urls = $data;
        }else{
            foreach($data as $image){
                if($image["$ext"]!=$opt_level){
                    $urls[]=$image;
                }
            }
        }

        return $urls;
    }

    // DB manipulation End

}

class Ir_Re_Checker{
    use GoWEBP_Checker;
    private static $Ir_recheck;
    private function __construct(){
        return $this->ir_send_req_to_server();
    }

    public static function get_instance(){
        if(self::$Ir_recheck == null){
           self::$Ir_recheck = new Ir_Re_Checker();
            return self::$Ir_recheck;
        }
        return self::$Ir_recheck;
    }
}

